#define AUTO_DLLMAIN
#include <DynRPG/DynRPG.h>

enum var_type { VAR_RND = 3,
                VAR_ITEM = 4,
                VAR_HERO = 5,
                VAR_SPRITE = 6};

int random;
std::pair<int, int> item;
std::pair<int, int> hero;
std::pair<int, int> range;
std::pair<int, int> sprite;

void onInitTitleScreen()
{
    random = 0;
    item.first = 0;
    item.second = 0;
    hero.first = 0;
    hero.second = 0;
    range.first = 0;
    range.second = 0;
    sprite.first = 0;
    sprite.second = 0;
}

bool onComment( const char* text,
                const RPG::ParsedCommentData* 	parsedData,
                RPG::EventScriptLine* 	nextScriptLine,
                RPG::EventScriptData* 	scriptData,
                int 	eventId,
                int 	pageId,
                int 	lineId,
                int* 	nextLineId )
{
    std::string cmd = parsedData->command;

    if(!cmd.compare("item_once"))
    {
        item.first = 1;
        item.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("item_fixed"))
    {
        item.first = -1;
        item.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("item_normal"))
    {
        item.first = 0;
        return false;
    }

    if(!cmd.compare("hero_once"))
    {
        hero.first = 1;
        hero.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("hero_fixed"))
    {
        hero.first = -1;
        hero.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("hero_normal"))
    {
        hero.first = 0;
        return false;
    }

    if(!cmd.compare("sprite_once"))
    {
        sprite.first = 1;
        sprite.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("sprite_fixed"))
    {
        sprite.first = -1;
        sprite.second = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("sprite_normal"))
    {
        sprite.first = 0;
        return false;
    }

    if(!cmd.compare("random_once"))
    {
        random = 1;
        range.first = parsedData->parameters[0].number;
        range.second = parsedData->parameters[1].number;
        return false;
    }
    if(!cmd.compare("random_fixed"))
    {
        random = -1;
        range.first = parsedData->parameters[0].number;
        range.second = parsedData->parameters[1].number;
        return false;
    }
    if(!cmd.compare("random_normal"))
    {
        random = 0;
        return false;
    }
}

bool onEventCommand (RPG::EventScriptLine *scriptLine,
                     RPG::EventScriptData *scriptData,
                     int eventId, int pageId,
                     int lineId, int *nextLineId)
{
    if(scriptLine->command == RPG::EVCMD_CHANGE_VARIABLE)
    {
        switch(scriptLine->parameter(4))
        {
            case VAR_RND:
                if(random != 0)
                {
                    scriptLine->parameters.items[5] = range.first;
                    scriptLine->parameters.items[6] = range.second;
                    if(random > 0) random = 0;
                    return true;
                }
                break;
            case VAR_ITEM:
                if(item.first != 0)
                {
                    scriptLine->parameters.items[5] = item.second;
                    if(item.first > 0) item.first = 0;
                    return true;
                }
                break;
            case VAR_HERO:
                if(hero.first != 0)
                {
                    scriptLine->parameters.items[5] = hero.second;
                    if(hero.first > 0) hero.first = 0;
                    return true;
                }
                break;
            case VAR_SPRITE:
                if(sprite.first != 0)
                {
                    scriptLine->parameters.items[5] = sprite.second;
                    if(sprite.first > 0) sprite.first = 0;
                    return true;
                }
                break;
            default:;
        }
    }
}
